/**
 * Class that handle a pdf that is read
 * @constructor
 * @param {function: string pdfcontent => void} onPdfRead - The callback called with the pdf conent in parameter
 */
function PdfReader(onPdfRead) {   

	this._onPdfRead = onPdfRead;

    PdfReader.prototype.read = function(pdfUrl) {

		var self = this;
	
		// Issues is here
	
		// Working
        PDFJS.workerSrc = 'https://cdn.jsdelivr.net/npm/pdfjs-dist@1.9.646/build/pdf.worker.js';
		
		// Both are not working, but I want to refer a local file within my extension to avoid CDN dependancy and internet connection issues.
		//PDFJS.workerSrc = chrome.extension.getURL("pdf.worker.js");
		//PDFJS.workerSrc = "pdf.worker.js";
		
		// End Issued is here
		
        var xhr = new XMLHttpRequest();
        xhr.open("GET", pdfUrl, true);
        xhr.responseType = "blob";
        xhr.onload = function(e) {
            var reader = new FileReader();
            reader.onload = function(event) {
                var text = event.target.result;
                var pdfContent = convertDataURIToBinary(text);
                PDFJS.getDocument(pdfContent).then(function(pdf) {
                    debugger;
					self.onGetDocument(pdf);
                }, function(reason) {
                    console.error(reason);
                });
            }
            var file = this.response;
            reader.readAsDataURL(file);
        };

        xhr.send();
    }

    PdfReader.prototype.onGetDocument = function(pdfDocument) {
        var pagesPromises = [];

        for (var i = 0; i < pdfDocument.pdfInfo.numPages; i++) {
            // Required to prevent that i is always the total of pages
            (function(pageNumber) {
                pagesPromises.push(getPageText(pageNumber, pdfDocument));
            })(i + 1);
        }
		
		var self = this;
		
        Promise.all(pagesPromises).then(function(pagesText) {
            var pdfContent = pagesText.join("/n");
            self._onPdfRead(pdfContent);
        });
    }

    function convertDataURIToBinary(dataURI) {
        var BASE64_MARKER = ';base64,';
        var base64Index = dataURI.indexOf(BASE64_MARKER) + BASE64_MARKER.length;
        var base64 = dataURI.substring(base64Index);
        var raw = window.atob(base64);
        var rawLength = raw.length;
        var array = new Uint8Array(new ArrayBuffer(rawLength));

        for (var i = 0; i < rawLength; i++) {
            array[i] = raw.charCodeAt(i);
        }

        return array;
    }
    
    function getPageText(pageNum, pdfDocument) {
        return new Promise(function(resolve, reject) {
            pdfDocument.getPage(pageNum).then(function(pdfPage) {
                pdfPage.getTextContent().then(function(textContent) {
                    var textItems = textContent.items;
                    var finalString = "";
                    for (var i = 0; i < textItems.length; i++) {
                        var item = textItems[i];
                        finalString += item.str + " ";
                    }
                    resolve(finalString);
                });
            });
        });
    }
}